!!!interface definition for the Vertical Interpolation package
!
!AUTHOR
!     J.W. Blezius DEC 2002
!
!REVISION
! v1_0    Blezius J.W.          - initial version
!
!OBJECT
!        To avoid maintaining *.mod files for each architecture for each revision
!        of the vertical interpolation package, this interface definition is
!        provided to be include'ed instead of use'ing the modules directly.
!
!NOTES
!        It is the responsibility of the programmer to ensure that this interface
!        definition matches the actual interface in the modules.
!
!        For backwards compatibility, any change to the interface must be
!        accompanied with a new name (e.g. append a revision number) for that
!        interface.
!
!!



interface
! The ViqkdefIfc interface definition fails with most compilers
! integer function N_ViqkdefIfc(that, n_numVLevelsIn, n_gridTypeIn, r_vLevelIn, &
!                               r_pTopAvgIn, r_pRefIn, r_rCoefIn)
!   include "ViTypes_f90.h"
!   type(T_VerticalGridIfc), intent(inout) :: that
!   integer, intent(in)::n_numVLevelsIn ! number of vertical levels in r_vLevelIn
!   integer, intent(in) :: n_gridTypeIn ! the type of grid -- see values above
!
!                                       ! the levels, see n_gridTypeIn for units
!   real, dimension(n_numVLevelsIn), intent(in) :: r_vLevelIn
!
!   ! These three arguments are optional as a group (for N_GRID_TYPE_HYBRID)
!   real, optional,intent(in)::r_pTopAvgIn ! average pressure (mb) at model top
!   real, optional,intent(in)::r_pRefIn ! reference pressure (mb)
!   real, optional,intent(in)::r_rCoefIn! known as 'expansion co-efficient'
! end function N_ViqkdefIfc


! The VidefsetIfc interface definition fails with most compilers
! integer function N_VidefsetIfc(n_niIn, n_njIn, o_vGridDestnPtrIn, &
!                             o_vGridSourcePtrIn, r_pSurf, r_pTopIn)
!   include "ViTypes_f90.h"
!   integer, intent(in)::n_niIn, n_njIn ! size of h grid in the interpolation
!
!                                       ! the two grids requested
!   type(T_VerticalGridIfc), intent(in) :: o_vGridDestnPtrIn, &
!                                          o_vGridSourcePtrIn
!
!                                       ! surface pressure at each horiz location
!   real, dimension(:,:), intent(in) :: r_pSurf
!
!                                       ! ceiling pressure for each horiz point
!                                       ! required only for eta units
!   real, target, dimension(:,:), optional :: r_pTopIn
! end function N_VidefsetIfc



  integer function N_VisetoptIfc(s_option, s_value)
    character(len=*), intent(in) :: s_option
    character(len=*), intent(in) :: s_value
  end function N_VisetoptIfc




  integer function N_VisintIfc(r_stateOut, r_stateIn, r_derivOut, r_derivIn, &
                            r_extrapGuideDown, r_extrapGuideUp)
    real, dimension(:,:,:), intent(out) :: r_stateOut
    real, dimension(:,:,:), intent(in)  :: r_stateIn
    real, dimension(:,:,:), optional, intent(out) :: r_derivOut
    real, dimension(:,:,:), optional, intent(in)  :: r_derivIn
    real, optional, intent(in) :: r_extrapGuideDown, r_extrapGuideUp
  end function N_VisintIfc
  
end interface
