* 
***S/P CCARD - RECUPERATION DES PARAMETRES D'APPEL A UN PROGRAMME
        SUBROUTINE CCARD(INCLE,DEF,VAL,N,II)
        USE IFLPORT
        INTEGER N,II
        CHARACTER * (*) INCLE(N), DEF(N), VAL(N)
*
*ADAPTATION: JAMES CAVEEN
*
*OBJET(CCARD)   -   RECUPERATION DES PARAMETRES D'APPEL A UN PROGRAMME
*                   SI LE NOM D'UNE CLEF APPARAIT SEUL LORS DE LA SEQUENCE
*                   D'APPEL, ON LUI ATTRIBUE LA VALEUR CONTENUE DANS DEF
*                   SI LE NOM APPARAIT, SUIVI D'UNE OU DES VALEURS, ON LUI
*                   ATTRIBUE CES VALEURS.  SINON, LA CLEF PREND POUR VALEUR
*                   LE CONTENU INITIAL DE VAL.
*
*                   ON PEUT DONNER UNE VALEUR A UNE CLEF DES FACONS
*                   SUIVANTES:
*
*                   -CLEF VALEUR
*                   -CLEF VAL1:VAL2:VAL3:...
*                   -CLEF 2:3:-4
*                   -CLEF =-2:3:4
*                   -CLEF =-22
*                   -CLE=-22:33:...           
*      
*                   LORS DE LA SEQUENCE D'APPEL, TOUS LES PARAMETRES
*                   PRECEDANT LA PREMIERE CLEF RENCONTREE ET
*                   SUIVANT LES SIGNES -- SONT TRAITES EN MODE POSITIONEL.
*
*                   EXEMPLES D'UTILISATION:
*
*                   PROGNOM -CLEF1 -CLEF2 VAL2 -- POS1 POS2
*                   PROGNOM POS1 POS2 -CLEF1 -- POS3 POS4 ...
*                   PROGNOM -CLEF1 =-12:33 -CLEF2 12 =-34
*
*                   LORSQUE LE PREMIER PARAMETRE PASSE = -H/-h, CCARD IMPRIME
*                   SUR L'UNITE 6 LA SEQUENCE D'APPEL AU PROGRAMME.
*                 
*                   LA SEQUENCE D'APPEL ET LES VALEURS COURANTES DES CLEFS
*                   SERONT IMPRIMEES S'IL Y A ERREUR LORS DE L'APPEL.
*
*
*ARGUMENTS:
*       INCLE     ENTREE     -  NOM DES DIFFERENTES CLEFS A INITIALISER
*       DEF          "       -  DEUXIEME VALEUR DE DEFAUT
*       VAL       SORTIE     -  VALEUR FINALE ATTRIBUEE AUX CLEFS
*       N         ENTREE     -  NOMBRE DE CLEFS A INITIALISER
*       II        SORTIE     -  NOMBRE DE PARAMETRES POSITIONNELS
*                               (I.E. ASSOCIES AUX CLEFS "-")
*                            -  SI II > 0, ON RETOURNE LE NOMBRE DE 
*                               PARAMETRES POSITIONELS.
*                            -  SI II = -111, ON ARRETE DES LA PREMIERE
*                               ERREUR
*                            -  SI II <=0 & <> -111, ON NE RETOURNE PAS
*                               LE NOMBRE D'ARGUMENTS POSITIONELS ET ON
*                               CONTINUE MALGRE LES ERREURS
*
**
        INTEGER QQQOBM,LONGUEUR
        EXTERNAL QQQOBM, QQQSAP, LOW2UP, QQQTRNS,LONGUEUR
        INTEGER I,POS,J,POSC,INDEX,CLLNG,POSMOIN,POSMOINC
* TYPE DE CLE -1=MINUS, 1=MAJUS, 0=PAREIL
        INTEGER CLTYPE(1024 )
        CHARACTER * 9 CLEUP, CLE(1024 )
        CHARACTER * 256 ARGUP, ARG
        LOGICAL PASFINI, PLANTE
        INTEGER STATUS, INTERNE
*
*       SI II = -111, LE PROGRAMME ARRETE DES LA PREMIERE 
*       ERREUR RENCONTREE SINON, ON CONTINUE
*
        IF (II .EQ. -111) THEN
            PLANTE = .TRUE.
        ELSE
            PLANTE = .FALSE.
        ENDIF
*
*       INITIALISER LE VECTEUR DE TYPE DE CLEFS
*
        DO 20 I = 1, N
            CALL LOW2UP(INCLE(I),CLEUP)
            DO 10 J =9,1,-1
                IF(CLEUP(J:J) .NE. ' ') THEN
                    INDEX = J
                    GOTO 11
                ENDIF
 10         CONTINUE
 11         CONTINUE
            IF(CLEUP(INDEX:INDEX) .EQ. '.') THEN
                CLTYPE(I) = 0
                CLEUP(INDEX:INDEX) = ' '
            ELSE IF (CLEUP(INDEX:INDEX) .EQ. '_') THEN
                CLTYPE(I) = -1
                CLEUP(INDEX:INDEX) = ' '
            ELSE
                CLTYPE(I) = 1
            ENDIF
            CLE(I) = CLEUP
 20     CONTINUE
*       TROUVER LA POSITION DE LA PREMIERE CLEF - DANS LA LISTE CLE
        POSMOIN = 0
        POSMOINC = 0
        DO 30 J=1,N
            IF(CLE(J) .EQ. '-') THEN
                  POSMOINC = J
                  POSMOIN  = J
                  GOTO 80
            ENDIF
 30     CONTINUE
 80     CONTINUE
        POS  = 0
        POSC = 0
        INTERNE   = 0
        PASFINI = .TRUE.
 100    CONTINUE
        IF (PASFINI) THEN
          STATUS = QQQOBM(ARG)
          IF(STATUS .EQ. 1) THEN
            CALL LOW2UP(ARG,ARGUP)
            DO 110 J = 1,N
              CLEUP = CLE(J)
              IF (ARGUP(1:8) .EQ. CLEUP(1:8)) THEN
                POSC = J
                POS = J
                CALL QQQTRNS(VAL(POS), DEF(POS),CLTYPE(POS))
                GOTO 201
              ENDIF
 110        CONTINUE
            CLLNG = LONGUEUR(ARGUP)
            PRINT *,' *** ERREUR: cle ',ARGUP(1:CLLNG),' non reconnue'
            CALL QQQSAP(CLE,DEF,VAL,N)
            IF(PLANTE) THEN
               STOP
            ENDIF
 201        CONTINUE
          ELSE IF(STATUS .EQ. 2) THEN
            IF (POSC .NE. 0 .AND. CLE(POS) .EQ. CLE(POSC)) THEN
              CALL QQQTRNS(VAL(POSC),ARG,CLTYPE(POSC))
              POSC = POSC + 1
            ELSE
              PRINT *,' *** ERREUR: debordement de liste'
              CALL QQQSAP(CLE,DEF,VAL,N)
              IF(PLANTE) THEN
                   STOP
              ENDIF
            ENDIF
          ELSE IF(STATUS .EQ. 3) THEN
            IF (POSMOINC .NE. 0 .AND. CLE(POSMOIN) .EQ. CLE(POSMOINC))
     %        THEN
              CALL QQQTRNS(VAL(POSMOINC),ARG,CLTYPE(POSMOINC))
            ELSE
              PRINT *,' *** ERREUR: debordement de liste'
              PRINT *,'         ou  mode positionnel non permis'
              CALL QQQSAP(CLE,DEF,VAL,N)
              IF(PLANTE) THEN
                   STOP
              ENDIF
            ENDIF
            POSMOINC = POSMOINC + 1
            INTERNE = INTERNE + 1
          ELSE IF(STATUS .EQ. 5) THEN
              CALL QQQSAP(CLE,DEF,VAL,N)
              STOP
          ELSE
             PASFINI = .FALSE.
          ENDIF
          GOTO 100
        ENDIF
*       RETOURNER LE NOMBRE D'ARGUMENTS ASSOCIES A LA CLEF - SI DEMANDE
        IF(II .GT. 0) THEN
           II = INTERNE
        ENDIF
        RETURN
        END
***S/P  QQQOBM - OBTENIR UN NOM DE CLEF OU UNE VALEUR D'UN ARGUMENT
*
        FUNCTION QQQOBM(ARG)
        USE IFLPORT
        INTEGER QQQOBM
        CHARACTER * 256 ARG
*
*AUTEUR          J.CAVEEN, JANVIER 1991
*
*OBJET(QQQOBM)
*       FONCTION QUI PERMET D'ALLER CHERCHER LES ARGUMENTS D'UNE SEQUENCE
*       D'APPEL A UN PROGRAMME ET D'EN EXTRAIRE LES NOMS DE CLEFS ET LES
*       VALEURS A DONNER A CES CLEFS.
*       LA FONCTION QQQOBM RETOURNE:
*            - UNE VALEUR DE 1 SI ARG CONTIENT UN NOM DE CLEF
*            - UNE VALEUR DE 2 SI ARG CONTIENT UNE VALEUR A DONNER A UNE CLEF
*            - UNE VALEUR DE 3 SI ARG CONTIENT UN ARGUMENT POSITIONEL
*            - UNE VALEUR DE 5 SI ON DEMANDE LA SEQUENCE D'APPEL
*            - UNE VALEUR DE 0 LORSQUE TOUT EST FINI
*
*ARGUMENT:
*         ARG    SORTIE     NOM DE CLEF OU VALEUR RETOURNE
*
**
        INTEGER LONGUEUR
        EXTERNAL LONGUEUR
        LOGICAL PASDCLE, PUDCLE, PREMIER
        INTEGER ARGNUM, IINDEX, INDFIN, NARG, I, INDEB, J
        CHARACTER *256 ARGUP
        SAVE ARGUP
        SAVE PASDCLE, PUDCLE, PREMIER, ARGNUM, NARG, IINDEX, INDFIN
        DATA PASDCLE, PUDCLE, PREMIER /.TRUE., .FALSE., .TRUE./
        DATA ARGNUM, NARG, IINDEX, INDFIN /0, 0, 0, 0/
*
 100    QQQOBM = 0
        DO 120 I = 1, 256
          ARG(I:I) = ' '
 120    CONTINUE
        IF(PREMIER) THEN
            NARG = IARGC()
            PREMIER = .FALSE.
        ENDIF
        IF(IINDEX .GE. INDFIN) THEN
*            #  ALLER CHERCHER UN ARGUMENT
             ARGNUM = ARGNUM + 1
             IF (ARGNUM .GT. NARG)   RETURN
             DO 150 I = 1,256
                 ARGUP(I:I) = ' '
 150         CONTINUE
             CALL GETARG(ARGNUM,ARGUP)
             IF(((NARG .EQ. 1) .AND. ((INDEX(ARGUP,'-H ') .NE. 0) .OR.
     %          (INDEX(ARGUP,'-h ') .NE. 0)))) THEN
                 QQQOBM = 5
                 RETURN
             ENDIF
             IINDEX = 1
*
*            TROUVER LA FIN DE ARGUP
*
             INDFIN = LONGUEUR(ARGUP)
         ENDIF
*
*         EXTRAIRE UN NOM DE CLEF OU UNE VALEUR
*
        IF((IINDEX .EQ. 1) .AND.  (ARGUP(1:1) .EQ. '-') .AND.
     %     (.NOT. PUDCLE)) THEN
*         NOM DE CLEF
            PASDCLE = .FALSE.
            QQQOBM = 1
            IINDEX = 2
            IF(ARGUP(2:2) .EQ. '-') THEN
                PUDCLE = .TRUE.
                GO TO 100
*               CHERCHER PROCHAIN ARG POSITIONEL
            ENDIF
        ELSE
* VALEUR A DONNER
            IF(PUDCLE .OR. PASDCLE) THEN
* ARGUMENT POSITIONEL
                 QQQOBM = 3
                 ARG = ARGUP
                 IINDEX = INDFIN
                 RETURN
            ELSE
                 QQQOBM = 2
            ENDIF
            IF((ARGUP(IINDEX:IINDEX) .EQ. ':') .OR.
     %         (ARGUP(IINDEX:IINDEX) .EQ. '='))
     %              IINDEX = IINDEX + 1
        ENDIF
        INDEB = IINDEX
        J = 1
        DO 200 I= INDEB ,INDFIN
            IF((ARGUP(I:I) .EQ. '=') .OR. (ARGUP(I:I) .EQ. ':')) THEN
                  GOTO 500
            ELSE
                 ARG(J:J) = ARGUP(I:I)
                 IINDEX = IINDEX +1
                 J = J + 1
            ENDIF
 200    CONTINUE
 500    CONTINUE
        RETURN
        END
***S/P - QQQTRNS - TRADUIRE ET TRANSFERER UNE VALEUR SELON LE TYPE
*
        SUBROUTINE QQQTRNS(SORTI,ENTRE,TYPE)
        USE IFLPORT
        CHARACTER*(*) SORTI,ENTRE
        INTEGER TYPE
*
*AUTEUR:   JAMES CAVEEN,  JUILLET 1991
*
*OBJET(QQQTRNS) - TRADUIRE UNE VALEUR EN MAJUSCULES/MINUSCULE SELON
*                 LE TYPE DE CLE ET TRANSFERE LE RESULTAT DANS SORTI
*
*ARGUMENTS    SORTI  SORTIE -  NOM RESULTANT DE LA TRANSFORMATION
*             ENTRE  ENTREE - NOM A TRADUIRE
*             TYPE      "   - TYPE DE TRADUCTION A APPLIQUER
*
**
        EXTERNAL LOW2UP, UP2LOW
        IF(TYPE .EQ. 1) THEN
           CALL LOW2UP(ENTRE,SORTI)
        ELSE IF(TYPE .EQ. -1) THEN
           CALL UP2LOW(ENTRE,SORTI)
        ELSE
           SORTI = ENTRE
        ENDIF
        RETURN
        END
***S/P QQQSAP - IMPRIMER LA SEQUENCE D'APPEL AU PROGRAMME
*
        SUBROUTINE QQQSAP(CLE,DEF,VAL,N)
         USE IFLPORT
        INTEGER N
        CHARACTER* (*) CLE(N), DEF(N), VAL(N)
*
*AUTEUR:  JAMES CAVEEN, JUILLET 1991
*
*OBJET(QQQSAP) - SOUS-PROGRAMME SERVANT A IMPRIMER LA SEQUENCE D'APPEL 
*                AU PROGRAMME PRESENTEMENT EN EXECUTION.
*                QQQSAP IMPRIME SUR L'UNITE 6: 
*                   LE NOM DU PROGRAMME, LES DIFFERENTS NOM DE CLEFS
*                   ET LEUR PREMIERE ET DEUXIEME VALEUR DE DEFAUT.
*
*ARGUMENTS:
*        CLE      ENTREE  - TABLEAU CONTENANT LE NOM DES N CLEFS
*        DEF      ENTREE  - TABLEAU CONTENANT LA DEUXIEME VALEUR DE DEFAUT
*        VAL      ENTREE  - TABLEAU CONTENANT LA PREMIERE VALEUR DE DEFAUT
*                           OU LA VALEUR COURANTE DE LA CLEF
*        N        ENTREE  - NOMBRE DE CLEFS
*
*
        INTEGER LONGUEUR
!       EXTERNAL GETARG
        EXTERNAL LONGUEUR
        CHARACTER*256 LENOM
        INTEGER I,NOMLNG,CLELNG,DEFLNG,VALLNG
*       ON OBTIENT LE NOM DU PROGRAMME APPELANT
        CALL GETARG(0,LENOM)
        WRITE(6,100)
        NOMLNG = LONGUEUR(LENOM)
        WRITE(6,*)LENOM(1:NOMLNG)
        DO 50 I =1,N
           CLELNG = LONGUEUR(CLE(I))
           DEFLNG = LONGUEUR(DEF(I))
           VALLNG = LONGUEUR(VAL(I))
           WRITE(6,200) CLE(I)(1:CLELNG),VAL(I)(1:VALLNG),
     %                  DEF(I)(1:DEFLNG)
 50     CONTINUE
 100    FORMAT(' *** SEQUENCE D''APPEL ***'//)
 200    FORMAT('     -',A,' [',A,':',A,']')
        RETURN
        END
