* 
***S/P IEEEPAK - COMPACTION / DECOMPACTION DE REELS ("format ieee")
*
      SUBROUTINE IEEEPAK(IFLD,IPK,NI,NJ,NPAK,serpas,KIND)
      IMPLICIT NONE
      INTEGER NI,NJ,IFLD(0:*),IPK(*),NPAK,KIND,serpas
*
*AUTHOR    - M. LEPINE  - Nov 91
*
*LANGUAGE - FORTRAN
*
*OBJET(IEEEPAK)
*         - COMPACTER OU DECOMPACTER DES NOMBRES REELS 
*           en format ieee  (1 signe 8 exposant 32-nbits mantisse)
*
*PRECISION
*         - L'ALGORITHME DE COMPACTION GARDE LES NBITS BITS LES
*           MOINS SIGNIFICATIFS.
*
*LIBRAIRIES
*
*ARGUMENTS
* IN/OUT  - IFLD - INTEGER ARRAY, UNPACKED (NI,NJ)
* IN/OUT  - IPK  - THE SAME ARRAY PACKED
*   IN    - NI   - X-DIMENSION
*   IN    - NJ   - Y-DIMENSION
*   IN    - NPAK - NPAK > 0, DENSITE DE COMPACTION
*                  NPAK = 0 OU 1, PAS DE COMPACTION
*                  NPAK < 0, NOMBRE DE BITS A GARDER PAR NOMBRE
*   IN    - kind - 1 = PACK
*                  2 = UNPACK
*   in    - serpas sert pas !!
**
*
*
*  COMMON XXPAKC  SERT A OBTENIR NWR, NBITS, ET IDATX DE XXPAK.
*  ------ ------
*
*  NWR    NOMBRE DE MOTS DE L'ENREGISTREMENT COMPACTE
*  NBITS  NOMBRE DE BITS UTILISES PAR ITEM
*  IDATX  UTILISE A LA DECOMPACTION POUR LE MOT NWR+1 (DATE GROUP)
*  XXPERR CODE D'ERREUR RETOURNE PAR XXPAK
*
      COMMON /XXPAKC/ NWR, NBITS, IDATX, XXPERR
      INTEGER NWR, NBITS, IDATX, XXPERR
*
*
*
      INTEGER I,INDX,ITEMP,LEFT,ITEM,NINJ,INEXT
      INTEGER RBITS, RLEFT, ISAVE
*
      XXPERR = 0
      IF (NPAK .GT. 1) THEN
        NBITS = MAX(1,32 /NPAK)
      ELSE IF (NPAK .LT. 0) THEN
        NBITS = MIN(32 ,-NPAK)
      ELSE
        NBITS = 32
      ENDIF
*
      NINJ = NI*NJ
*
      RBITS = ishft(-1,-(32 -( NBITS )))
      NWR = (NINJ*NBITS+ 32 -1) / 32
*
      IF (KIND .EQ. 1) THEN
*                                               COMPACTER
        IF (NBITS .EQ. 32 ) THEN
          DO 10 I = 0,NWR-1
            IPK(I+1) = IFLD(I)
 10       CONTINUE
*         CALL MOVLEV(IFLD,IPK,NWR)
        ELSE
          INDX = 0
          LEFT = 32
          ITEMP = 0
          DO 100 I=0,NINJ-1
            ITEM = IAND(ishft( IFLD(I) ,-( 32-NBITS ))  , RBITS)
            IF (NBITS .LE. LEFT) THEN
              ITEMP = IOR(ishft( ITEMP , NBITS )  , ITEM)
              LEFT = LEFT - NBITS
            ELSE
              INDX = INDX+1
              IPK(INDX) = IOR(ishft( ITEMP , LEFT )  , ishft( ITEM ,-( N
     %BITS-LEFT )) )
              ITEMP = IAND(ITEM , ishft(-1,-(32 -( NBITS-LEFT ))) )
              LEFT = LEFT - NBITS + 32
            ENDIF
 100      CONTINUE
          IF (LEFT .LT. 32 ) THEN
            INDX = INDX + 1
            IPK(INDX) = IOR(ishft( ITEMP , LEFT ) ,IAND(IPK(INDX),ishft(
     %-1,-(32 -( LEFT ))) ))
          ENDIF
        ENDIF
      ELSE
*                                               DECOMPACTER
        IF (NBITS .EQ. 32 ) THEN
          DO 110 I = 0,NWR-1
            IFLD(I) = IPK(I+1)
 110      CONTINUE
        ELSE
          ITEMP = 0
          ISAVE = IPK(1+ITEMP)
          DO 120 I=NWR,2,-1
            IFLD(I-NWR+NINJ-1) = IPK(I+ITEMP)
 120      CONTINUE
          INDX = (NINJ-NWR) + 1
          LEFT = 32
          ITEMP = ishft( ISAVE , 32 -LEFT )
          INEXT = IFLD(INDX)
          DO 200 I=0,NINJ-1
            IF (NBITS .LE. LEFT) THEN
              IFLD(I) = IAND(ishft( ITEMP ,-( 32 -NBITS )) ,RBITS)
              ITEMP = ishft( ITEMP , NBITS )
              LEFT = LEFT - NBITS
            ELSE
              RLEFT = ishft(-1,-(32 -( NBITS-LEFT )))
              IFLD(I) = IOR(IAND(IAND(ishft( ITEMP ,-( 32 -NBITS )) ,RBI
     %TS),
     %                  NOT( RLEFT ) ),IAND(ishft( INEXT ,-( 32 -(NBITS-
     %LEFT) )) ,
     %                  RLEFT))
              INDX = INDX+1
              ITEMP = ishft( INEXT , NBITS-LEFT )
              INEXT = IFLD(INDX)
              LEFT = LEFT - NBITS + 32
            ENDIF
            IFLD(I) = ishft( IFLD(I) , 32-NBITS )
 200      CONTINUE
        ENDIF
      ENDIF
*
      RETURN
      END
