      subroutine tmg_init ( id, string )
      implicit none
*
      character* (*) string
      integer id
*
*
      integer maxtmg,my_pe
      parameter (maxtmg=100)
      character*12 evy
      character*60 msg(maxtmg)
      complex *16 r8irtc
      real*8 r8ivecc, r8ifpec
      real*8 tmg_of(maxtmg), tmg_cf(maxtmg),
     $       tmg_ot(maxtmg), tmg_ct(maxtmg), c1, r1
      external r8ivecc, r8ifpec, r8irtc
      common /tmg_1/ tmg_of, tmg_cf, tmg_ot, tmg_ct, c1, r1
      common /tmg_2/ evy,msg
      common /tmg_3/ my_pe
*
*     ---------------------------------------------------------------
      my_pe = id
      evy   = string
      tmg_cf= 0.d0
      tmg_ct= 0.d0
      c1    = 2.d0/1.0d9
      r1    = 1.0d6
      msg   = '@#$%^&'
*     ---------------------------------------------------------------
*
      return
      end
*
      subroutine tmg_terminate ( id )
      implicit none
*
      integer id
*
*
      integer maxtmg,my_pe
      parameter (maxtmg=100)
      character*12 evy
      character*60 msg(maxtmg)
      complex *16 r8irtc
      real*8 r8ivecc, r8ifpec
      real*8 tmg_of(maxtmg), tmg_cf(maxtmg),
     $       tmg_ot(maxtmg), tmg_ct(maxtmg), c1, r1
      external r8ivecc, r8ifpec, r8irtc
      common /tmg_1/ tmg_of, tmg_cf, tmg_ot, tmg_ct, c1, r1
      common /tmg_2/ evy,msg
      common /tmg_3/ my_pe
*
      integer i
*     ---------------------------------------------------------------
*
      if (evy(1:3).ne.'YES') then
         do i = 1, maxtmg
         if (msg(i).ne.'@#$%^&') then
             if (tmg_ct(i).lt.1.)
     $       write (6,200) my_pe,msg(i),tmg_ct(i),
     $                 tmg_cf(i),tmg_cf(i)/tmg_ct(i)/r1
             if ((tmg_ct(i).ge.1.).and.(tmg_ct(i).lt.10000.))
     $       write (6,201) my_pe,msg(i),tmg_ct(i),
     $                 tmg_cf(i),tmg_cf(i)/tmg_ct(i)/r1
             if (tmg_ct(i).ge.10000.)
     $       write (6,202) my_pe,msg(i),tmg_ct(i),
     $                 tmg_cf(i),tmg_cf(i)/tmg_ct(i)/r1
         endif
         end do
      endif
 200  format ('###TMG: PE=',i3,1x,a8,f12.8,f20.0,f10.3)
 201  format ('###TMG: PE=',i3,1x,a8,f12.4,f20.0,f10.3)
 202  format ('###TMG: PE=',i3,1x,a8,f12.0,f20.0,f10.3)
*     ---------------------------------------------------------------
*
      return
      end
*
      subroutine tmg_start ( id, string )
      implicit none
*
      character* (*) string
      integer id
*
*
      integer maxtmg,my_pe
      parameter (maxtmg=100)
      character*12 evy
      character*60 msg(maxtmg)
      complex *16 r8irtc
      real*8 r8ivecc, r8ifpec, rtools_wtime
      real*8 tmg_of(maxtmg), tmg_cf(maxtmg),
     $       tmg_ot(maxtmg), tmg_ct(maxtmg), c1, r1
      external r8ivecc, r8ifpec, r8irtc, rtools_wtime
      common /tmg_1/ tmg_of, tmg_cf, tmg_ot, tmg_ct, c1, r1
      common /tmg_2/ evy,msg
      common /tmg_3/ my_pe
*
*     ---------------------------------------------------------------
      if (id.gt.maxtmg) return
      msg(id)    = string
      tmg_of(id) =        0.
      tmg_ot(id) = rtools_wtime()
*     ---------------------------------------------------------------
*
      return
      end
*
      subroutine tmg_stop ( id )
      implicit none
*
      integer id
*
*
      integer maxtmg,my_pe
      parameter (maxtmg=100)
      character*12 evy
      character*60 msg(maxtmg)
      complex *16 r8irtc
      real*8 r8ivecc, r8ifpec, rtools_wtime
      real*8 tmg_of(maxtmg), tmg_cf(maxtmg),
     $       tmg_ot(maxtmg), tmg_ct(maxtmg), c1, r1
      external r8ivecc, r8ifpec, r8irtc, rtools_wtime
      common /tmg_1/ tmg_of, tmg_cf, tmg_ot, tmg_ct, c1, r1
      common /tmg_2/ evy,msg
      common /tmg_3/ my_pe
*
      integer i
*     ---------------------------------------------------------------
      if (id.gt.maxtmg) return
      tmg_cf(id) = 0.
      tmg_ct(id) = tmg_ct(id) + (rtools_wtime() - tmg_ot(id))
*
      if (evy(1:3).eq.'YES') then
          if (tmg_ct(id).lt.1.)
     $    write (6,200) my_pe,msg(id),tmg_ct(id),
     $              tmg_cf(id),tmg_cf(id)/tmg_ct(id)/r1
          if ((tmg_ct(id).ge.1.).and.(tmg_ct(id).lt.10000.))
     $    write (6,201) my_pe,msg(id),tmg_ct(id),
     $              tmg_cf(id),tmg_cf(id)/tmg_ct(id)/r1
          if (tmg_ct(id).ge.10000.)
     $    write (6,202) my_pe,msg(id),tmg_ct(id),
     $              tmg_cf(id),tmg_cf(id)/tmg_ct(id)/r1
         tmg_cf(id) = 0.
         tmg_ct(id) = 0.
      endif
*
 200  format ('###TMG: PE=',i3,1x,a8,f12.8,f20.0,f10.3)
 201  format ('###TMG: PE=',i3,1x,a8,f12.4,f20.0,f10.3)
 202  format ('###TMG: PE=',i3,1x,a8,f12.0,f20.0,f10.3)
*     ---------------------------------------------------------------
*
      return
      end
