***S/P RPN_COMM_optn options package
	SUBROUTINE RPN_COMM_optn(op_type,op_ival,op_rval,op_cval)
	implicit none
	character *(*) op_type, op_cval
	integer op_ival
	real *4 op_rval
**
        include 'rpn_comm.h'
        include 'mpif.h'
*
	integer i
	integer RESTE
	parameter (RESTE=MAX_OPTN-1)
	data pe_optn/'FILL',RESTE*'    '/
	data pe_opcv/MAX_OPTN*'    '/
	data pe_oprv/MAX_OPTN*0.0/
	data pe_opiv/MAX_OPTN*0/
*
	do i=1,MAX_OPTN
	  if(op_type .eq. pe_optn(i)) then
	    pe_opiv(i) = op_ival
	    pe_oprv(i) = op_rval
	    pe_opcv(i) = op_cval
	    return
	  endif
	enddo
*
	print *,'ERROR(RPN_COMM_optn) option ',op_type,' unknown'
*
	return
	end
*
***S/P RPN_COMM_tmg_wrt timing package
	SUBROUTINE RPN_COMM_tmg_wrt(Iun)
	implicit none
	integer Iun
*arguments
*  I	Iun	file to write timings into
**
        include 'rpn_comm.h'
        include 'mpif.h'
*
	external r8ivecc, r8ifpec, r8irtc
	real *8 r8ivecc, r8ifpec
	complex *16 r8irtc
	integer i,j,ip,nwds,ipe,status,ierr,tag,me,totpe
	integer MAXWDS
	parameter(MAXWDS=MAXTMG*MAXTMGELEM)
*
	data tmg_indx / 0 /
	data tmg_old /MAXTMGELEM * 0.0/
	data tmg_new /MAXTMGELEM * 0.0/
	data tmg_tbl /MAXWDS * 0.0/
*
*	temporary patch to allow programs using MSG to
*	collect statistics, information is avalilable
*	in pe_me and pe_tot
*
	call MPI_COMM_RANK(MPI_COMM_WORLD,me,ierr)
	call MPI_COMM_SIZE(MPI_COMM_WORLD,totpe,ierr)
*
	nwds = MAXTMGELEM*MAXTMG
*
*	PE 0 will write its own timings,
*	collect timings from other processors
*	and write the collected timings.
*	All messages are sent at FULL size, but tmg_tbl(1,1)
*	contains the useful number of timings collected by a PE
*
	if(me .eq. 0) then  ! I am the ROOT (PE = 0)
	  write(Iun)totpe,MAXTMGELEM,MAXTMG
	  if(tmg_indx.gt.1) write(Iun)0,MAXTMGELEM,tmg_indx-1,
     %              ((tmg_tbl(i,j),i=1,MAXTMGELEM),j=2,tmg_indx)
	  do ip = 1,totpe-1  ! loop over other PEs
	    ipe = ip
	    tag = ipe
	    call MPI_RECV(tmg_tbl,nwds,MPI_DOUBLE_PRECISION,ipe,
     %         tag,MPI_COMM_WORLD,status,ierr)
	    tmg_indx = tmg_tbl(1,1)
*	    DO NOT WRITE empty timing records
	    if(tmg_indx.gt.1) write(Iun)ipe,MAXTMGELEM,tmg_indx-1,
     %                ((tmg_tbl(i,j),i=1,MAXTMGELEM),j=2,tmg_indx)
	  enddo
	else  ! I am an ordinary PE, send timings to ROOT (PE = 0)
	  ipe = 0
	  tag = me
	  tmg_tbl(1,1) = tmg_indx
	  call MPI_SSEND(tmg_tbl,nwds,MPI_DOUBLE_PRECISION,ipe,
     %           tag,MPI_COMM_WORLD,ierr)
	endif
	return
*
***ENTRY RPN_COMM_tmg
	entry RPN_COMM_tmg
*notes
*	main timing point, timings are collected and counter
*	is incremented
**

1	tmg_indx=max(1,min(MAXTMG,tmg_indx+1))
	tmg_new(TMG_CLOCK) = MPI_wtime()
	tmg_new(TMG_CPU)   = dimag(r8irtc())
	tmg_new(TMG_VEC)   = r8ivecc()
	tmg_new(TMG_FLOP ) = r8ifpec()
	do i=1,MAXTMGELEM
	  tmg_tbl(i,tmg_indx) = tmg_new(i) - tmg_old(i)
	  tmg_old(i) = tmg_new(i)
	  tmg_new(i) = 0
	enddo

	return
***ENTRY RPN_COMM_tmg_in
	entry RPN_COMM_tmg_in
*
*notes
*	special entry called when a communication routine is entered
*	it it used to collect overhead statistics
**

	tmg_old(TMG_CPU_C) = dimag(r8irtc())
	tmg_old(TMG_CLOCK_C) = real(r8irtc())

	return
***ENTRY RPN_COMM_tmg_in
	entry RPN_COMM_tmg_out
*
*notes
*	special entry called when a communication routine is exited
*	it it used to collect overhead statistics
**

	tmg_new(TMG_CPU_C) = tmg_new(TMG_CPU_C) +
     %                       dimag(r8irtc())-tmg_old(TMG_CPU_C)
	tmg_new(TMG_CLOCK_C) = tmg_new(TMG_CLOCK_C) +
     %                         real(r8irtc())-tmg_old(TMG_CLOCK_C)
	tmg_old(TMG_CPU_C) = 0
	tmg_old(TMG_CLOCK_C) = 0

	return

	end
*
***S/P RPN_COMM_init
	SUBROUTINE RPN_COMM_init(Userinit,Pelocal,Petotal,Pex,Pey)
	implicit none
	integer Pelocal,Petotal,Pex,Pey
	external Userinit
*arguments
*  I	Userinit	User routine that will be called by PE 0 to
*		get the processor grid topology if it is not supplied
*		(Pex .eq. 0 ) or (Pey .eq. 0)
*  O	Pelocal	PE rank (number) of local PE
*  O	Petotal	Number of PEs in job
*  I/O	Pex	Number of PEs along the X axis. If Pex=0 upon entry
*		it will be set to the proper value upon exit
*  I/O	Pey	Number of PEs along the Y axis. If Pey=0 upon entry
*		it will be set to the proper value upon exit
*
*notes
*	processor topology common /pe/ will be filled here
*	positions are calculated from 0 (ORIGIN 0)
**
*
	include 'rpn_comm.h'
	include 'mpif.h'
*
	integer ierr, i, j, count, npe, reste, nslots
	logical mpi_started
	integer worldcomm
	INTEGER worldgroup,newgroup,range(3,0:MAX_PE_Y),rowcomm
*
	call MPI_INITIALIZED(mpi_started,ierr)
	if (.not. mpi_started ) call MPI_init(ierr)
	call MPI_COMM_RANK(MPI_COMM_WORLD,pe_me,ierr)
	Pelocal = pe_me
	call MPI_COMM_SIZE(MPI_COMM_WORLD,pe_tot,ierr)
	Petotal = pe_tot
	worldcomm = MPI_COMM_WORLD
*
	if( pe_me .eq. 0 )then
	  if ( Pex.eq.0 .or. Pey.eq.0  ) then ! get processor topology
	    call Userinit(WORLD_pex,WORLD_pey)
	    print *,'Requested topology = ',WORLD_pex,' by ',WORLD_pey
          else
	    WORLD_pex = Pex
	    WORLD_pey = Pey
	  endif
*
	  if(WORLD_pex*WORLD_pey .gt. pe_tot) then
	    print *,' ERROR: not enough PEs for decomposition '
	    print *,' REQUESTED=',WORLD_pex*WORLD_pey,
     %              ' AVAILABLE=',pe_tot
	    stop
	  endif
	endif
*
*	send WORLD topology to all PEs. That will allow all PEs
*	to compute other PE topology parameters locally.
*
	call MPI_BCAST(WORLD_pex,2,MPI_INTEGER,0,
     %	               MPI_COMM_WORLD,ierr)
	if ( Pex.eq.0 .or. Pey.eq.0  ) then ! return processor topology
	  Pex = WORLD_pex
	  Pey = WORLD_pey
	endif
*
	pe_nx=WORLD_pex
	pe_ny=WORLD_pey
*
*	pe_pe0 is not equal to 0 if there are PEs out of the
*	computational grid
*
	pe_pe0 = pe_tot - (WORLD_pex*WORLD_pey)
	count = pe_pe0
*
*	fill tables containing the position along the X axis (pe_xtab)
*	and along the Y axis (pe_ytab) for all processors
*
	do i=0,count-1
	  pe_xtab(i)=-1
	  pe_ytab(i)=-1
	  ord_tab(i)=-1
	enddo

	ord_tab(0)=0
	ord_max=-1
	if(pe_pe0.gt.0)ord_max=ord_max+1
	
	do j=0,pe_ny-1
	do i=0,pe_nx-1
	  pe_id(i,j)=count
	  pe_xtab(count)=i
	  pe_ytab(count)=j
	  ord_max=ord_max+1
	  ord_tab(ord_max)=count
	  if(pe_me.eq.count)ord_me=ord_max
	  count=count+1
	enddo
	enddo
*
*	fill processor topology matrix, including a border used
*	to find "neighbors" in case of periodic domain
*
	do j=-1,pe_ny
	  pe_id(-1,j) = pe_id(pe_nx-1,j)
	  pe_id(pe_nx,j) = pe_id(0,j)
	enddo
	do i=-1,pe_nx
	  pe_id(i,-1) = pe_id(i,pe_ny-1)
	  pe_id(i,pe_ny) =  pe_id(i,0)
	enddo
	if(pe_me.eq.0)then
	  print *,'PE MATRIX :'
	  do j=pe_ny,-1,-1
	    print 101,(pe_id(i,j),i=-1,pe_nx)
101	format(30I3)
	  enddo
	  print *,'PE_xtab :'
	  print 101,(pe_xtab(i),i=0,pe_tot-1)
	  print *,'PE_ytab :'
	  print 101,(pe_ytab(i),i=0,pe_tot-1)
	  print *,'ordinals table'
	  print 101,(ord_tab(i),i=0,ord_max)
	endif
*
*	compute position of PE in the computational grid
*	a value of -1 for X or Y means "OUT OF GRID"
*
	if(pe_me.lt.pe_pe0) then
	  pe_mex=-1
	  pe_mey=-1
	  pe_extra=1
	  print *,'PE=',pe_me,' out of RPW/COL groups'
	else
	  pe_mex=mod(pe_me-pe_pe0,pe_nx)
	  pe_mey=(pe_me-pe_pe0)/pe_nx
	  pe_extra=0
	endif
*
*	are we on a boundary ?
*
	bnd_south=pe_mey.eq.0
	bnd_north=pe_mey.eq.pe_ny-1
	bnd_west=pe_mex.eq.0
	bnd_east=pe_mex.eq.pe_nx-1
*
*	split communication domain into
*	IN GRID  vs  OUT OF GRID domains
*
	pe_grid = MPI_COMM_NULL
	call MPI_COMM_SPLIT(MPI_COMM_WORLD,
     %	                   pe_extra,pe_me,pe_grid,ierr)
*
	call MPI_COMM_GROUP(MPI_COMM_WORLD,worldgroup,ierr)
*
*	split communication domain into rows
*
	pe_myrow=MPI_COMM_NULL
*	do j=0,pe_ny-1
*	  do i=0,pe_nx-1
*	    range(1,i)=pe_id(i,j)
*	    range(2,i)=pe_id(i,j)
*	    range(3,i)=1
*	  enddo
*	  call MPI_GROUP_RANGE_INCL(worldgroup,pe_nx,range,
*     %                              newgroup,ierr)
*	  call MPI_COMM_CREATE(MPI_COMM_WORLD,newgroup,rowcomm,ierr)
*	  if(j .eq. pe_mey) pe_myrow=rowcomm
*	enddo
	call MPI_COMM_SPLIT(worldcomm,pe_mey+1,pe_mex+1,pe_myrow,ierr)
*
*	split communication domain into columns
*
	pe_mycol=MPI_COMM_NULL
*	do i=0,pe_nx-1
*	  do j=0,pe_ny-1
*	    range(1,j)=pe_id(i,j)
*	    range(2,j)=pe_id(i,j)
*	    range(3,j)=1
*	  enddo
*	  call MPI_GROUP_RANGE_INCL(worldgroup,pe_ny,range,
*     %                              newgroup,ierr)
*	  call MPI_COMM_CREATE(MPI_COMM_WORLD,newgroup,rowcomm,ierr)
*	  if (i .eq. pe_mex) pe_mycol=rowcomm
*	enddo
	call MPI_COMM_SPLIT(worldcomm,pe_mex+1,pe_mey+1,pe_mycol,ierr)
*
*	precompute the secondary distribution table for the
*	global grid distribute and collect operations
*	pe_dtab(0) contains the number of secondary distributors
*	pe_dtab(1..nslots) contain the PE numbers (in ascending order)
*	of the secondary distributors
*	a simple attempt is made to get a reasonably efficient setup
*
	nslots = .9999 + sqrt(pe_tot-1.0)
	reste = pe_tot - 1
	pe_dtab(0) = nslots
	pe_dtab(1) = 1
	do i = 1,nslots
	  npe = (reste + nslots - i)/(nslots-i+1)
	  reste = reste - npe
	  pe_dtab(i+1) = pe_dtab(i) + npe
	enddo
	if (pe_me .eq. 0) then
	  print *,'PE_dtab='
	  print 101,(pe_dtab(i),i=0,nslots+1)
	endif
*
	return
	end
*
***S/R RPN_COMM_dist  Global distribution of data
	subroutine RPN_COMM_dist(garr,nig,njg,nk,size,
     %          larr,mini,maxi,minj,maxj,status)
	implicit none
*
	include 'rpn_comm.h'
	include 'mpif.h'
*
	integer nig,njg,size,mini,maxi,minj,maxj,nk,status
	integer garr(size,nig,njg,nk)
	integer larr(size,mini:maxi,minj:maxj,nk)
*
*arguments
*  I	garr	array containing data to distribute, USED ONLY by PE 0
*  I	nig,njg,nk
*		dimensions of garr
*  I	size	size of data elements (the size of an integer is 1)
*  O	larr	local array that will receive the part of the global
*		domain that belongs to the local PE
*  I	mini:maxi,minj:maxj
*		dimensions of larr
*  O	status	status code upon exit
**
	integer MAX_PENDING
	parameter (MAX_PENDING=4)
	logical distribute
	integer i,j,k,ierr,nslots,nwords,i0,j0,level,temp,nil,njl,islot
	integer clientpe,isz,ilst,j1,client,jlocal,islot0
	integer ipe, jpe, istatus(MPI_STATUS_SIZE)
	integer PEND_STAT(MPI_STATUS_SIZE)
	integer PEND_REQ(0:MAX_PENDING-1)
	pointer (temp_, temp(size,mini:maxi,minj:maxj,nk,0:*))
	pointer (ilst_, ilst(mini:maxi))
*
	distribute = .true.
1	status=MPI_ERROR
#ifndef TWO_LEVEL_DIST
	if(pe_me .eq.0) then
*
*	PE # 0, get own stuff, distribute rest to others
*
	  nil=(nig+pe_nx-1)/pe_nx
	  njl=(njg+pe_ny-1)/pe_ny
	  j0=0
	  islot = 0
	  do jpe=0,pe_ny-1
	    i0=0
	    do ipe=0,pe_nx-1
*
*	get own part of global array
*
	      if(pe_id(ipe,jpe) .eq. 0)then
	        do j=minj,maxj
	          do i=mini,maxi
	            ilst(i)=i0+i
	            if(ilst(i).gt.nig) ilst(i)=ilst(i)-nig
	            if(ilst(i).lt.0)   ilst(i)=ilst(i)+nig
	          enddo
	          jlocal=j0+j
	          if(jlocal.gt.njg) jlocal=jlocal-njg
	          if(jlocal.lt.0)   jlocal=jlocal+njg
	          do isz=1,size
	          do k=1,nk
	          do i=mini,maxi
	            larr(isz,i,j,k)=garr(isz,ilst(i),jlocal,k)
	          enddo
	          enddo
	          enddo
	        enddo
*
*	distribute to others using a pipelined method
*
	      else
	        islot0=mod(islot,MAX_PENDING)
	        do j=minj,maxj
	          do i=mini,maxi
	            ilst(i)=i0+i
	            if(ilst(i).gt.nig) ilst(i)=ilst(i)-nig
	            if(ilst(i).lt.0)   ilst(i)=ilst(i)+nig
	          enddo
	          jlocal=j0+j
	          if(jlocal.gt.njg) jlocal=jlocal-njg
	          if(jlocal.lt.0)   jlocal=jlocal+njg
	          do isz=1,size
	          do k=1,nk
	          do i=mini,maxi
	            temp(isz,i,j,k,islot0)=garr(isz,ilst(i),jlocal,k)
	          enddo
	          enddo
	          enddo
	        enddo
	        call MPI_ISEND(temp(1,1,1,1,islot0),
     %	               size*nk*(maxi-mini+1)*(maxj-minj+1),
     %	               MPI_INTEGER,pe_id(ipe,jpe),pe_id(ipe,jpe),
     %	               MPI_COMM_WORLD,
     %	               PEND_REQ(mod(islot,MAX_PENDING)),ierr)
	        if(islot-MAX_PENDING.ge.0)then
	          call MPI_WAIT(
     %	               PEND_REQ(mod(islot-MAX_PENDING,MAX_PENDING)),
     %	               PEND_STAT,ierr)
	        endif
                islot=islot+1
	      endif
	      i0=i0+nil
	    enddo
	    j0=j0+njl
	  enddo
	  do i=max(0,islot-MAX_PENDING-1),islot-1
	    call MPI_WAIT(PEND_REQ(1-mod(i-MAX_PENDING,MAX_PENDING)),
     %	         PEND_STAT,ierr)
	  enddo
	else
*
*	NOT pe # 0, passive receive
*
	  call MPI_RECV(larr,size*nk*(maxi-mini+1)*(maxj-minj+1),
     %	                MPI_INTEGER,0,
     %	                pe_me,MPI_COMM_WORLD,istatus,ierr)
	endif
#else
*
*	level = 0 for root pe
*	level = 1 for secondary distributor pe
*	level = 2 for client only pe
*
	level = 2
	if(pe_me.eq.0) level = 0
	do i = 1,pe_dtab(0)
	  if(pe_me .eq. pe_dtab(i)) then
	    level = 1
	    islot = i
	  else if(pe_me .gt. pe_dtab(i)) then
	    islot = i
	  endif
	enddo
	nslots = pe_dtab(2) - pe_dtab(1)
*
*	allocate multi local block buffer if needed
*	(level 0 and level 1 PEs)
*	dummy allocation for consistency for level 2 PEs
*
	nwords = nslots * (maxi-mini+1) * (maxj-minj+1) * nk * size
	if(level .eq. 2) nwords = 10
	nwords = nwords + (maxi-mini+1)
	call stkmemw(nwords,ilst_)
	temp_ = loc(ilst(maxi+1))
*
*	nil = largest value of local dimension along X
*	pe_itab contains the starting index in the global
*	   array for a processor with a given position
*	   along X in the processor grid (origin 0)
*
	nil = (nig+pe_nx-1)/pe_nx
	do i = 0,pe_nx-1
	  pe_itab(i) = i*nil + 1
	enddo
	pe_itab(pe_nx) = nig + 1
*
*	njl = largest value of local dimension along Y
*	pe_jtab contains the starting index in the global
*	   array for a processor with a given position
*	   along Y in the processor grid (origin 0)
*
	njl = (njg+pe_ny-1)/pe_ny
	do j = 0,pe_ny-1
	  pe_jtab(j) = j*njl + 1
	enddo
	pe_jtab(pe_ny) = njg + 1
*
	if(level .eq. 0) then  ! send to all level 1 PEs
*
*	root PE (0) : allocate buffer, loop ever level 1 PEs
*	prepare data for easy redistribution, cubes are
*	prepackaged including halo area to minimize data
*	movement for receiving PE
*	HALO AREA OF LOCAL DATA IS NOT INITIALIZED
*
*	collect local data before sending to others
*
	  i0 = pe_itab(pe_xtab(0))
	  j0 = pe_jtab(pe_ytab(0))
	  if(i0.gt.0 .and. j0.gt.0) then
	    do i = mini,maxi
	      ilst(i) = i0+i-1
	      if(ilst(i) .le. 0) ilst(i)=ilst(i)+nil
	      if(ilst(i) .gt. nil) ilst(i)=ilst(i)-nil
	    enddo
	    do j = minj,maxj  ! fill local data cube including halo
	      j1 = j0+j+1
	      if(j1 .le. 0) j1=j1+njl
	      if(j1 .gt. njl) j1=j1-njl
	      do isz = 1,size
	      do k = 1,nk
	      do i = mini,maxi
	        larr(isz,i,j,k) = garr(isz,ilst(i),j1,k)
	      enddo
	      enddo
	      enddo
	    enddo
	  endif
	  do 100 islot = 1,nslots  ! loop over level 1 PEs
*
	    nwords = (maxi-mini+1) * (maxj-minj+1) * nk * size *
     %               (pe_dtab(islot+1) - pe_dtab(islot))
*
	    do 50 clientpe = pe_dtab(islot),pe_dtab(islot+1)-1
*
*	    loop over all clients of level 1 PE (including itself)
*
	      client = clientpe - pe_dtab(islot) + 1
	      i0 = pe_itab(pe_xtab(clientpe))
	      j0 = pe_jtab(pe_ytab(clientpe))
	      if(i0.le.0 .or. j0.le.0) goto 50  ! clientpe in grid ?
	      do i = mini,maxi
	        ilst(i) = i0+i-1
	        if(ilst(i) .le. 0) ilst(i)=ilst(i)+nil
	        if(ilst(i) .gt. nil) ilst(i)=ilst(i)-nil
	      enddo
	      do j = minj,maxj  ! fill local data cube including halo
	        j1 = j0+j+1
	        if(j1 .le. 0) j1=j1+njl
	        if(j1 .gt. njl) j1=j1-njl
	        do isz = 1,size
	        do k = 1,nk
	        do i = mini,maxi
	          temp(isz,i,j,k,client) = garr(isz,ilst(i),j1,k)
	        enddo
	        enddo
	        enddo
	      enddo
*
50	    enddo
*
*	    send tag is the PE rank of the receiving PE
*
	    call MPI_SSEND(temp,nwords,MPI_INTEGER,pe_dtab(islot),
     %                     pe_dtab(islot),MPI_COMM_WORLD,ierr)
	    if(ierr.ne.MPI_SUCCESS) goto 1111
100	  enddo
	else if(level .eq.1) then  ! receive from root and redistribute
*
*	level 1 PE, receive data block from PE 0
*	move local data into local array
*	redistribute data to dependant level 2 PEs
*
	  nwords = (maxi-mini+1) * (maxj-minj+1) * nk * size *
     %             (pe_dtab(islot+1) - pe_dtab(islot))
	  call MPI_RECV(temp,nwords,MPI_INTEGER,0,
     %                  pe_me,MPI_COMM_WORLD,PEND_STAT,ierr)
	  if(ierr.ne.MPI_SUCCESS) goto 1111
*
	  nwords = (maxi-mini+1) * (maxj-minj+1) * nk * size
*
	  call movlev(temp,larr,nwords)  ! get local data
*
*	  distribute to level 2 PEs
*
	  do clientpe = pe_dtab(islot)+1,pe_dtab(islot+1)-1
	    call MPI_SSEND(temp(1,1,1,1,clientpe+1-pe_dtab(islot)),
     %                     nwords,MPI_INTEGER,clientpe,
     %                     clientpe,MPI_COMM_WORLD,ierr)
	  if(ierr.ne.MPI_SUCCESS) goto 1111
	  enddo
	else  ! level 2, receive from level 1 PE
	  nwords = (maxi-mini+1) * (maxj-minj+1) * nk * size 
*
*	  receive tag is the rank of the receiving PE i.e. pe_me
*	  no data move is necessary, data is pre_packaged
*
	  call MPI_RECV(larr,nwords,MPI_INTEGER,pe_dtab(islot),
     %                  pe_me,MPI_COMM_WORLD,PEND_STAT,ierr)
	  if(ierr.ne.MPI_SUCCESS) goto 1111
	endif
#endif
*
	status=MPI_SUCCESS
	return
*
1111	status =  MPI_ERROR
	call unstakw(ilst_)
	return
***entry RPN_COMM_coll Global data collect
	entry RPN_COMM_coll(garr,nig,njg,nk,size,
     %          larr,mini,maxi,minj,maxj,status)
**
	distribute = .false.
	goto 1
*
	end
*
***FUNCTION RPN_COMM_mype find PE identity and grid position
	integer function RPN_COMM_mype(Me,Me_x,Me_y)
*
	implicit none
	integer Me,Me_x,Me_y
*arguments
*  O	Me	PE rank (number)
*  O	Me_x	X coordinate of PE in computational grid
*  O	Me_y	Y coordinate of PE in computational grid
**
	include 'rpn_comm.h'
	include 'mpif.h'
*
	Me = pe_me
	Me_x = pe_mex
	Me_y = pe_mey
*
	RPN_COMM_mype=MPI_SUCCESS
*
	return
	end
***FUNCTION RPN_COMM_topo 1D data topology to PE topology mapper
	integer function RPN_COMM_topo(nxg,minx,maxx,nxl,nxlmax,
     %                   halox,nx0,alongx,fill)
	implicit none
	integer nxg,minx,maxx,nxl,nxlmax,halox,nx0
	logical fill, alongx
*
*arguments
*  I	nxg	Global dimension (1D) of data
*  O	minx,maxx
*		dimensions for local array
**
	include 'rpn_comm.h'
	include 'mpif.h'
*
	integer pe_nxy(2), pe_mexy(2)
	equivalence(pe_nxy(1),pe_nx)
	equivalence(pe_mexy(1),pe_mex)
	integer indx
*
	if(alongx)then
	  indx=1
	else
	  indx=2
	endif
	minx = 1 - halox
	nxlmax = (nxg + pe_nxy(indx) - 1) /  pe_nxy(indx)
	nx0 = 1 + nxlmax*pe_mexy(indx)
	maxx = nxlmax + halox
	if(fill) maxx = maxx + 1 - mod(nxlmax,2)
	nxl = min(nxlmax,nxg-nx0+1)

	RPN_COMM_topo = 0
*	if(nxl.le.0) RPN_COMM_topo = 1
	if(nxlmax*(pe_nxy(indx)-1) .gt. nxg) RPN_COMM_topo = 1
*
	return
	end
*
	integer function RPN_COMM_topo_xy(nig,njg,mini,maxi,minj,maxj,
     %          nil,njl,haloi,haloj,peri,perj)
	implicit none
	integer nig,njg,mini,maxi,minj,maxj
	integer nil,njl,haloi,haloj
	logical peri,perj
*
	include 'rpn_comm.h'
	include 'mpif.h'
*
	mini = 1-haloi
	minj = 1-haloj
	nil = (nig + pe_nx - 1)/pe_nx
	njl = (njg + pe_ny - 1)/pe_ny
        if (pe_me .eq.0) then
*	  print *,' RPN_COMM_topo: nig,njg=',nig,njg
*	  print *,' RPN_COMM_topo: nil,njl=',nil,njl
*	  print *,' RPN_COMM_topo: pe_nx,pe_ny=',pe_nx,pe_ny
	endif
	maxi = nil + haloi + 1 - mod(nil,2)
	maxj = njl + haloj + 1 - mod(njl,2)
        nil = min(nil,nig-nil*(pe_mex))
        njl = min(njl,njg-njl*(pe_mey))
	RPN_COMM_topo_xy = MPI_SUCCESS
	if(nil.le.0 .or. njl.le.0) RPN_COMM_topo_xy = MPI_ERROR
	return
	end
*
	SUBROUTINE RPN_COMM_transpose(
     %             za,min1,max1,n1g,n2,min3,max3,n3g,zb,type,size)
	implicit none
	integer min1,max1,n1g,n2,min3,max3,n3g,type,size
	integer za(size,min1:max1,n2,n3g)
	integer zb(size,n2,min3:max3,n1g)
*
	include 'rpn_comm.h'
	include 'mpif.h'
*
	integer n3partiel,n1partiel,npe,pecomm
*
	if(abs(type).eq.1) then   ! transpose along X
	  npe=pe_nx
	  pecomm=pe_myrow
	else                      ! transpose along Y
	  npe=pe_ny
	  pecomm=pe_mycol
	endif
	n3partiel=(n3g+npe-1)/npe
	n1partiel=(n1g+npe-1)/npe
*
*	check that min1>0, max1>=n1partiel
*	check that min3>0, max3>=n3partiel
*	check that size = 1 or 2 (integer/real, real*8)
*
	if(type.gt.0) then  ! forward transpose
*
	  call RPN_COMM_Xpose1(n3partiel,npe,pecomm,
     %       n1partiel,
     %       za,min1,max1,n1g,n2,min3,max3,n3g,zb,size)
*
	else ! backward transpose
*
	  call RPN_COMM_Xpose2(n3partiel,npe,pecomm,
     %       n1partiel,
     %       za,min1,max1,n1g,n2,min3,max3,n3g,zb,size)
*
	endif
*
	return
	end
*
	SUBROUTINE RPN_COMM_Xpose1(n3partiel,npe,pecomm,
     %   n1partiel,za,min1,max1,n1g,n2,min3,max3,n3g,zb,size)
*
*	forward transpose, za to zb
*	gather first dimension into processor,
*	distribute last dimension
*	result array has gathered index as last dimension
*	(last dimension of arrays is always in-processor)
*
	implicit none
	integer n3partiel,n1partiel,npe,pecomm,size
	integer min1,max1,n1g,n2,min3,max3,n3g
	integer za(size,min1:max1,n2,n3g)
	integer zb(size,n2,min3:max3,n1g)
*
	real *8 za8(size/2,min1:max1,n2,n3g)
	real *8 zb8(size/2,n2,min3:max3,n1g)
	pointer (za8_,za8)
	pointer (zb8_,zb8)
*
	include 'rpn_comm.h'
	include 'mpif.h'
*
	integer ta
	pointer(ta_,ta(size,n2,min3:max3,n1partiel,npe))
	real *8 ta8
	pointer(ta_,ta8(size/2,n2,min3:max3,n1partiel,npe))
*
	external stkmemw
	integer i,j,k,iter,i0,ierr,isz,isz2,n3w
	logical odd
*
	za8_ = loc(za)
	zb8_ = loc(zb)
	isz2 = size/2
	odd = isz2*2 .ne. size
	if(odd) isz2=size
	n3w = max3-min3+1
*
	if(npe.eq.1)then
	  do isz=1,isz2
	  do k=1,n3g
	  do j=1,n2
	    if(odd) then
	      do i=1,n1g
	        zb(isz,j,k,i)=za(isz,i,j,k)
	      enddo
	    else
	      do i=1,n1g
	        zb8(isz,j,k,i)=za8(isz,i,j,k)
	      enddo
	    endif
	  enddo
	  enddo
	  enddo
	  return
	endif
*
	call stkmemw(size*n1partiel*n2*n3w*npe,ta_)
*
	do isz=1,isz2
	i0 = 0
	do k=1,n3g,n3partiel
	 i0 = 1+i0
	 do i=1,n1partiel
	  if(odd) then
	    do j=1,n2*min(n3partiel,n3g+1-k)
	      ta(isz,j,min3,i,i0)=za(isz,i,j,k)
	    enddo
	  else
	    do j=1,n2*min(n3partiel,n3g+1-k)
	      ta8(isz,j,min3,i,i0)=za8(isz,i,j,k)
	    enddo
	  endif
	 enddo
	enddo
	enddo
*
	call MPI_ALLTOALL(
     %       ta,size*n1partiel*n2*n3w,MPI_INTEGER,
     %       zb,size*n1partiel*n2*n3w,MPI_INTEGER,
     %       pecomm,ierr)
*
	call unstakw(ta_)
*
	return
	end
*
	SUBROUTINE RPN_COMM_Xpose2(n3partiel,npe,pecomm,
     %   n1partiel,za,min1,max1,n1g,n2,min3,max3,n3g,zb,size)
*
*	backward transpose, zb to za
*	(last dimension of arrays is always in-processor)
*
	implicit none
	integer n3partiel,n1partiel,npe,pecomm,size
	integer min1,max1,n1g,n2,min3,max3,n3g
	integer za(size,min1:max1,n2,n3g)
	integer zb(size,n2,min3:max3,n1g)
*
	real *8 za8(size/2,min1:max1,n2,n3g)
	real *8 zb8(size/2,n2,min3:max3,n1g)
	pointer (za8_,za8)
	pointer (zb8_,zb8)
*
	include 'rpn_comm.h'
	include 'mpif.h'
*
	integer ta
	pointer(ta_,ta(size,n2,min3:max3,n1partiel,npe))
	real *8 ta8
	pointer(ta_,ta8(size/2,n2,min3:max3,n1partiel,npe))
*
	external stkmemw
	integer i,j,k,iter,i0,ierr,isz,isz2,n3w
	logical odd
*
	za8_ = loc(za)
	zb8_ = loc(zb)
	isz2 = size/2
	odd = isz2*2 .ne. size
	if(odd) isz2=size
	n3w = max3-min3+1
*
*
	if(npe.eq.1)then
	  do isz=1,isz2
	  do k=1,n3g
	  do j=1,n2
	    if(odd) then
	      do i=1,n1g
	        za(isz,i,j,k)=zb(isz,j,k,i)
	      enddo
	    else
	      do i=1,n1g
	        za8(isz,i,j,k)=zb8(isz,j,k,i)
	      enddo
	    endif
	  enddo
	  enddo
	  enddo
	  return
	endif
*
	call stkmemw(size*n1partiel*n2*n3w*npe,ta_)
*
	call MPI_ALLTOALL(
     %       zb,size*n1partiel*n2*n3w,MPI_INTEGER,
     %       ta,size*n1partiel*n2*n3w,MPI_INTEGER,
     %       pecomm,ierr)
*
	do isz=1,isz2
	i0 = 0
	do k=1,n3g,n3partiel
	 i0 = 1+i0
	 do i=1,n1partiel
	  if(odd) then
	    do j=1,n2*min(n3partiel,n3g+1-k)
	      za(isz,i,j,k)=ta(isz,j,min3,i,i0)
	    enddo
	  else
	    do j=1,n2*min(n3partiel,n3g+1-k)
	      za8(isz,i,j,k)=ta8(isz,j,min3,i,i0)
	    enddo
	  endif
	 enddo
	enddo
	enddo
*
	call unstakw(ta_)
*
	return
	end
*
	SUBROUTINE RPN_COMM_xch_halox(g,minx,maxx,miny,maxy,
     %             ni,nj,nk,halox,haloy,periodx,periody,
     %	           g2,minx2,maxx2,miny2,maxy2,gni,npol_row)
	implicit none
*
*	exchange a halo with neighbours
*
	integer minx,maxx,miny,maxy,ni,nj,nk,halox,haloy
	integer minx2,maxx2,miny2,maxy2
	integer gni,npol_row
	logical periodx,periody
	integer g(minx:maxx,miny:maxy,nk)
	integer g2(minx2:maxx2,miny2:maxy2,nk)
*
	include 'rpn_comm.h'
	include 'mpif.h'
*
	integer i,j,k
*
	do i=1,ni
	do j=1,nj
	do k=1,nk
	  g2(i,j,k)=g(i,j,k)
	enddo
	enddo
	enddo
*
	call RPN_COMM_xch_halo(g2,minx2,maxx2,miny2,maxy2,
     %             ni,nj,nk,halox,haloy,periodx,periody,
     %             gni,npol_row)
*
	return
	end
	SUBROUTINE RPN_COMM_xch_halo(g,minx,maxx,miny,maxy,
     %             ni,nj,nk,halox,haloy,periodx,periody,
     %             gni,npol_row)
	implicit none
*
*	exchange a halo with neighbours
*
	integer minx,maxx,miny,maxy,ni,nj,nk,halox,haloy
	integer gni,npol_row
	logical periodx,periody
	integer g(minx:maxx,miny:maxy,nk)
*
	include 'rpn_comm.h'
	include 'mpif.h'
*
	integer wkxs,wkxr,wkys,wkyr,wk,wks,wkr,wkslag,wkgth
	pointer(wk_,wk(10))
	pointer(wkr_,wkr(10))
	pointer(wks_,wks(10))
	pointer(wkxs_,wkxs(minx:maxx,nk,halox))
	pointer(wkxr_,wkxr(minx:maxx,nk,halox))
	pointer(wkys_,wkys(miny:maxy,nk,haloy))
	pointer(wkyr_,wkyr(miny:maxy,nk,haloy))
	pointer(wkslag_,wkslag(miny:maxy,nk,10))
	pointer(wkgth_,wkgth(miny:maxy,nk,10))
*
	external stkmemw
*
	integer nwdsx,nwdsy,nwds,halo,nwdslag
	integer i, j, k, m
	integer sendtag, gettag, ierr
	integer status(MPI_STATUS_SIZE)
	logical east,west,north,south
	integer eastpe,westpe,northpe,southpe
*
	integer globalni,polarrows
*
	integer land_fill
	real r_land_fill
	equivalence(land_fill,r_land_fill)
*
	globalni=gni
	polarrows=npol_row
1	continue
	call RPN_COMM_tmg_in
*
	east=(bnd_east) .and. (.not.periodx)
	eastpe=pe_id(pe_mex+1,pe_mey)
	west=(bnd_west) .and. (.not.periodx)
	westpe=pe_id(pe_mex-1,pe_mey)
	north=(bnd_north) .and. (.not.periody)
	northpe=pe_id(pe_mex,pe_mey+1)
	south=(bnd_south) .and. (.not.periody)
	southpe=pe_id(pe_mex,pe_mey-1)
*
	nwdsx=(maxx-minx+1)*nk*halox+2
	nwdsx=nwdsx+mod(nwdsx,2)
	nwdsy=(maxy-miny+1)*nk*haloy+2
	nwdsy=nwdsy+mod(nwdsy,2)
	nwds=max(nwdsx,nwdsy)
*
*	allocate temporary arrays on stack
*
	if (min(pe_mey+1,pe_ny-pe_mey).le.polarrows .and. pe_nx.gt.1) then
	  nwdslag=(maxy-miny+1)*nk*((globalni+pe_nx-1)/pe_nx)*
     %            (pe_nx+1)
	  call stkmemw(max(nwdslag,nwds*2)+2,wk_)
	else
	  call stkmemw(nwds*2+2,wk_)
	endif
	wks_=wk_
	wkslag_=wk_
	wkr_=loc(wk(nwds+1))
	wkxr_=loc(wk(nwds+2))
	wkyr_=loc(wk(nwds+2))
	wkxs_=loc(wk(2))
	wkys_=loc(wk(2))
*
	if(pe_opcv(1) .ne. '    ') then         !   fill halo option present
	  r_land_fill=pe_oprv(1)
	  if(pe_opcv(1) .eq. 'BAND') then
	    if(iand(1,pe_opiv(1)) .ne. 0) then  ! south band
	      do j=miny,0
	        do k=1,nk
	        do i=minx,maxx
	          g(i,j,k)=land_fill
	        enddo
	        enddo
	      enddo
	    endif
	    if(iand(2,pe_opiv(1)) .ne. 0) then  ! east band
	      do i=ni+1,maxx
	        do j=miny,maxy
	        do k=1,nk
	          g(i,j,k)=land_fill
	        enddo
	      enddo
	      enddo
	    endif
	    if(iand(4,pe_opiv(1)) .ne. 0) then  ! north band
	      do j=nj+1,maxy
	        do k=1,nk
	        do i=minx,maxx
	          g(i,j,k)=land_fill
	        enddo
	        enddo
	      enddo
	    endif
	    if(iand(8,pe_opiv(1)) .ne. 0) then  ! west band
	      do i=minx,0
	        do j=miny,maxy
	        do k=1,nk
	          g(i,j,k)=land_fill
	        enddo
	      enddo
	      enddo
	    endif
	  endif
	  if(pe_opcv(1) .eq. 'EDGE') then
	    if(iand(1,pe_opiv(1)) .ne. 0) then  ! south edge
	      do i=minx,0
	        do k=1,nk
	          g(i,1,k)=land_fill
	        enddo
	      enddo
	      do i=ni+1,maxx
	        do k=1,nk
	          g(i,1,k)=land_fill
	        enddo
	      enddo
	    endif
	    if(iand(2,pe_opiv(1)) .ne. 0) then  ! east edge
	      do j=miny,0
	        do k=1,nk
	          g(ni,j,k)=land_fill
	        enddo
	      enddo
	      do j=nj+1,maxy
	        do k=1,nk
	          g(ni,j,k)=land_fill
	        enddo
	      enddo
	    endif
	    if(iand(4,pe_opiv(1)) .ne. 0) then  ! north edge
	      do i=minx,0
	        do k=1,nk
	          g(i,nj,k)=land_fill
	        enddo
	      enddo
	      do i=ni+1,maxx
	        do k=1,nk
	          g(i,nj,k)=land_fill
	        enddo
	      enddo
	    endif
	    if(iand(8,pe_opiv(1)) .ne. 0) then  ! west edge
	      do j=miny,0
	        do k=1,nk
	          g(1,j,k)=land_fill
	        enddo
	      enddo
	      do j=nj+1,maxy
	        do k=1,nk
	          g(1,j,k)=land_fill
	        enddo
	      enddo
	    endif
	  endif
	endif
*
	halo=haloy
	if (halo .eq. 0) goto 1111
	if ( pe_ny.eq.1 ) then
          if(periody)then
	    do m=1,halo
	    do k=1,nk
	    do i=minx,maxx
	      g(i,nj+m,k)=g(i,m,k)
	      g(i,m-halo,k)=g(i,nj+m-halo,k)
	    enddo
	    enddo
	    enddo
          endif
	  goto 1111
	endif
*
*
*  process north to south move
*
	do m=1,halo
	do k=1,nk
	do i=minx,maxx
	  wkxs(i,k,m)=g(i,m,k)
	enddo
	enddo
	enddo
	do i=1,nwdsx
	  wkr(i)=0
	enddo
	wks(1)=pe_me
	wks(nwdsx)=southpe
	sendtag=pe_me
	gettag=northpe
	if(north) then
*	  send to south_neighbor
	  if(.not.south)then
	    call MPI_SSEND(wks,nwdsx,MPI_INTEGER,southpe,
     %	         sendtag,MPI_COMM_WORLD,ierr)
	  endif
	  wkr(1)=northpe
	  wkr(nwdsx)=pe_me
	else if(south) then
*	  receive from north_neighbor
	  call MPI_RECV(wkr,nwdsx,MPI_INTEGER,northpe,
     %	       gettag,MPI_COMM_WORLD,status,ierr)
	else
*	  send to south_neighbor and receive from north_neighbor
	  call MPI_SENDRECV(wks,nwdsx,MPI_INTEGER,southpe,sendtag,
     %	                    wkr,nwdsx,MPI_INTEGER,northpe,gettag,
     %	                    MPI_COMM_WORLD,status,ierr)
	endif
	if(wkr(1).ne.northpe .or. wkr(nwdsx).ne.pe_me) then
	  print *,'PE=',pe_me,' N->S error,',wkr(1),wkr(nwdsx),
     %	    ' should be ',northpe,pe_me
	  stop
	endif
	if(.not.north)then
	do m=1,halo
	do k=1,nk
	do i=minx,maxx
	  g(i,nj+m,k)=wkxr(i,k,m)
	enddo
	enddo
	enddo
	endif
*
*
*  process south to north move
*
	halo=haloy
	do m=1,halo
	do k=1,nk
	do i=minx,maxx
	  wkxs(i,k,m)=g(i,nj+m-halo,k)
	enddo
	enddo
	enddo
	do i=1,nwdsx
	  wkr(i)=0
	enddo
	wks(1)=pe_me
	wks(nwdsx)=northpe
	sendtag=pe_me
	gettag=southpe
	if(south) then
*	  send to north_neighbor
	  if(.not.north)then
	    call MPI_SSEND(wks,nwdsx,MPI_INTEGER,northpe,
     %	         sendtag,MPI_COMM_WORLD,ierr)
	  endif
	  wkr(1)=southpe
	  wkr(nwdsx)=pe_me
	else if(north) then
*	  receive from south_neighbor
	  call MPI_RECV(wkr,nwdsx,MPI_INTEGER,southpe,
     %	       gettag,MPI_COMM_WORLD,status,ierr)
	else
*	  send to north_neighbor and receive from south_neighbor
	  call MPI_SENDRECV(wks,nwdsx,MPI_INTEGER,northpe,sendtag,
     %	                    wkr,nwdsx,MPI_INTEGER,southpe,gettag,
     %	                    MPI_COMM_WORLD,status,ierr)
	endif
	if(wkr(1).ne.southpe .or. wkr(nwdsx).ne.pe_me) then
	  print *,'PE=',pe_me,' N->S error,',wkr(1),wkr(nwdsx),
     %	    ' should be ',southpe,pe_me
	  stop
	endif
	if(.not.south)then
	do m=1,halo
	do k=1,nk
	do i=minx,maxx
	  g(i,m-halo,k)=wkxr(i,k,m)
	enddo
	enddo
	enddo
	endif
*
1111	continue
*
	halo=halox
	if (halo .eq. 0) goto 2222
*
*	if within polarrows rows from a pole, no lateral exchange
*	but a lateral domain gather. Polarrows is zero for a normal
*	halo exchange. It may be nonzero for a semi-lag exchange.
*
	if (min(pe_mey+1,pe_ny-pe_mey).le.polarrows) then
	  goto 2222
	endif
	if ( pe_nx.eq.1 ) then
	  if(periodx) then
	    do m=1,halo
	    do k=1,nk
	    do j=miny,maxy
	      g(m-halo,j,k)=g(ni+m-halo,j,k)
	      g(ni+m,j,k)=g(m,j,k)
	    enddo
	    enddo
	    enddo
	  endif
	  goto 2222
	endif
*
*
*  process west to east move
*
	do m=1,halo
	do k=1,nk
	do j=miny,maxy
	  wkys(j,k,m)=g(ni+m-halo,j,k)
	enddo
	enddo
	enddo
	do i=1,nwdsy
	  wkr(i)=0
	enddo
	wks(1)=pe_me
	wks(nwdsy)=eastpe
	sendtag=pe_me
	gettag=westpe
*	
	if(west) then
*	  send to east_neighbor
	  if(.not.east)then
	    call MPI_SSEND(wks,nwdsy,MPI_INTEGER,eastpe,
     %	         sendtag,MPI_COMM_WORLD,ierr)
	  endif
	  wkr(1)=westpe
	  wkr(nwdsy)=pe_me
	else if(east) then
*	  receive from west_neighbor
	  call MPI_RECV(wkr,nwdsy,MPI_INTEGER,westpe,
     %	       gettag,MPI_COMM_WORLD,status,ierr)
	else
*	  send to east_neighbor and receive from west_neighbor
	  call MPI_SENDRECV(wks,nwdsy,MPI_INTEGER,eastpe,sendtag,
     %                      wkr,nwdsy,MPI_INTEGER,westpe,gettag,
     %	                    MPI_COMM_WORLD,status,ierr)
	endif
	if(wkr(1).ne.westpe .or. wkr(nwdsy).ne.pe_me) then
	  print *,'PE=',pe_me,' W->E error,',wkr(1),wkr(nwdsy),
     %	    ' should be ',westpe,pe_me
	  stop
	endif
	if(.not.west)then
	do m=1,halo
	do k=1,nk
	do j=miny,maxy
	  g(m-halo,j,k)=wkyr(j,k,m)
	enddo
	enddo
	enddo
	endif
*
*
*  process east to west move
*
	halo=halox
	do m=1,halo
	do k=1,nk
	do j=miny,maxy
	  wkys(j,k,m)=g(m,j,k)
	enddo
	enddo
	enddo
	do i=1,nwdsy
	  wkr(i)=0
	enddo
	wks(1)=pe_me
	wks(nwdsy)=westpe
	sendtag=pe_me
	gettag=eastpe
*	
	if(east) then
*	  send to west_neighbor
	  if(.not.west) then
	    call MPI_SSEND(wks,nwdsy,MPI_INTEGER,westpe,
     %	         sendtag,MPI_COMM_WORLD,ierr)
	  endif
	  wkr(1)=eastpe
	  wkr(nwdsy)=pe_me
	else if(west) then
*	  receive from east_neighbor
	  call MPI_RECV(wkr,nwdsy,MPI_INTEGER,eastpe,
     %	       gettag,MPI_COMM_WORLD,status,ierr)
	else
*	  send to west_neighbor and receive from east_neighbor
	  call MPI_SENDRECV(wks,nwdsy,MPI_INTEGER,westpe,sendtag,
     %	                    wkr,nwdsy,MPI_INTEGER,eastpe,gettag,
     %	                    MPI_COMM_WORLD,status,ierr)
	endif
	if(wkr(1).ne.eastpe .or. wkr(nwdsy).ne.pe_me) then
	  print *,'PE=',pe_me,' W->E error,',wkr(1),wkr(nwdsy),
     %	    ' should be ',westpe,pe_me
	  stop
	endif
	if(.not.east)then
	do m=1,halo
	do k=1,nk
	do j=miny,maxy
	  g(ni+m,j,k)=wkyr(j,k,m)
	enddo
	enddo
	enddo
	endif
*
2222	continue
*
*	special case for Semi-Lag transport
*
	if (min(pe_mey+1,pe_ny-pe_mey).le.polarrows) then
*
	  if(pe_nx.eq.1) goto 3333
*
*	  get rid of halo along x
*
	  do j=miny,maxy
	  do k=1,nk
	  do i=1,ni
	    wkslag(j,k,i)=g(i,j,k)
	  enddo
	  enddo
	  enddo
	  wkgth_=loc(wkslag(miny,1,1+(globalni+pe_nx-1)/pe_nx))
*
*	  gather from wkslag of all row PEs int wkgth
*
	  nwdslag=((globalni+pe_nx-1)/pe_nx)*(maxy-miny+1)*nk
	  call MPI_ALLGATHER(wkslag,nwdslag,MPI_INTEGER,
     %         wkgth,nwdslag,MPI_INTEGER,
     %         pe_myrow,ierr)
*
*	  copy from temporary buffer into user array
*
	  do j=miny,maxy
	  do k=1,nk
	  do i=1,gni
	    g(i,j,k)=wkgth(j,k,i)
	  enddo
	  enddo
	  enddo
*
*	  now the final touch, the EW periodicity
*
3333	  continue
	  do i=1,halox
	  do j=miny,maxy
	  do k=1,nk
	    g(1-i,j,k)=g(globalni+1-i,j,k)
	    g(globalni+i,j,k)=g(i,j,k)
	  enddo
	  enddo
	  enddo
	endif
4444	call unstakw(wk_)
*
	if(polarrows.gt.0) then
	  call MPI_BARRIER(pe_grid,ierr)
	endif
	call RPN_COMM_tmg_out
*
	return
	entry xch_halo(g,minx,maxx,miny,maxy,
     %             ni,nj,nk,halox,haloy,periodx,periody)
	globalni=ni
	polarrows=0
	goto 1
	end
*
	SUBROUTINE RPN_COMM_gather_e1y3(srca,srcc,srcr,
     %        min1,max1,min2,max2, n1,n2,n3,dest,size)
	implicit none
	integer min1,max1,min2,max2,n1,n2,n3,size
	real dest(size,*)
	real srca(size,min1:max1,min2:max2,n3)
	real srcc(size,min1:max1,min2:max2,n3)
	real srcr(size,min1:max1,min2:max2,n3)
*
	include 'rpn_comm.h'
	include 'mpif.h'
*
	real zxij
	pointer (zij_,zxij(size,2*((n2*n3)/2)+1,6))
	real *8 zxij8
	pointer (zij_,zxij8(size/2,2*((n2*n3)/2)+1,6))
*
	real zyij
	pointer (zij_,zyij(size,2*((n1*n3)/2)+1,6))
	real *8 zyij8
	pointer (zij_,zyij8(size/2,2*((n1*n3)/2)+1,6))
*
	real *8 srca8(size/2,min1:max1,min2:max2,n3)
	real *8 srcc8(size/2,min1:max1,min2:max2,n3)
	real *8 srcr8(size/2,min1:max1,min2:max2,n3)
	pointer (srca8_,srca8)
	pointer (srcc8_,srcc8)
	pointer (srcr8_,srcr8)
*
	integer i,j,k,ie,isz,incr,ierr,nwords,mode,direction
	integer size2
*
	nwords=6*(2*((n2*n3)/2)+1)*size
	mode=1
	direction=pe_mycol
*
1	call stkmemw(nwords,zij_)
	srca8_=loc(srca)
	srcc8_=loc(srcc)
	srcr8_=loc(srcr)
*
	size2 = size
	if(mod(size,2).eq.0) size2 = size/2
*
	if(mode.eq.1)then    ! edge 1 (along x or y )
	  do isz=1,size2
	   incr=0
	   do j=1,n2
	    if(size.eq.size2)then
	     do k=1,n3
	      zxij(isz,incr+k,1) = srca(isz, 1,j,k)
	      zxij(isz,incr+k,4) = srca(isz,n1,j,k)
	      zxij(isz,incr+k,2) = srcc(isz, 1,j,k)
	      zxij(isz,incr+k,5) = srcc(isz,n1,j,k)
	      zxij(isz,incr+k,3) = srcr(isz, 1,j,k)
	      zxij(isz,incr+k,6) = srcr(isz,n1,j,k)
	     enddo
	    else
	     do k=1,n3
	      zxij8(isz,incr+k,1) = srca8(isz, 1,j,k)
	      zxij8(isz,incr+k,4) = srca8(isz,n1,j,k)
	      zxij8(isz,incr+k,2) = srcc8(isz, 1,j,k)
	      zxij8(isz,incr+k,5) = srcc8(isz,n1,j,k)
	      zxij8(isz,incr+k,3) = srcr8(isz, 1,j,k)
	      zxij8(isz,incr+k,6) = srcr8(isz,n1,j,k)
	     enddo
	    endif
	    incr=incr+n3
	   enddo
	  enddo
	else                  !  edge 2 (along x or y)
	  do isz=1,size2
	   incr=0
	   do i=1,n1
	    if(size.eq.size2)then
	     do k=1,n3
	      zyij(isz,incr+k,1) = srca(isz,i, 1,k)
	      zyij(isz,incr+k,4) = srca(isz,i,n2,k)
	      zyij(isz,incr+k,2) = srcc(isz,i, 1,k)
	      zyij(isz,incr+k,5) = srcc(isz,i,n2,k)
	      zyij(isz,incr+k,3) = srcr(isz,i, 1,k)
	      zyij(isz,incr+k,6) = srcr(isz,i,n2,k)
	     enddo
	    else
	     do k=1,n3
	      zyij8(isz,incr+k,1) = srca8(isz,i, 1,k)
	      zyij8(isz,incr+k,4) = srca8(isz,i,n2,k)
	      zyij8(isz,incr+k,2) = srcc8(isz,i, 1,k)
	      zyij8(isz,incr+k,5) = srcc8(isz,i,n2,k)
	      zyij8(isz,incr+k,3) = srcr8(isz,i, 1,k)
	      zyij8(isz,incr+k,6) = srcr8(isz,i,n2,k)
	     enddo
	    endif
	    incr=incr+n3
	   enddo
	  enddo
	endif
*
	call MPI_ALLGATHER(zxij,nwords,MPI_REAL,
     %                     dest,nwords,MPI_REAL,
     %                     direction,ierr)
	call unstakw(zij_)
	return
*
	entry RPN_COMM_gather_e1x3(srca,srcc,srcr,
     %        min1,max1,min2,max2, n1,n2,n3,dest,size)
*
	nwords=6*(2*((n2*n3)/2)+1)*size
	mode=1
	direction=pe_myrow
	goto 1
*
	entry RPN_COMM_gather_e2y3(srca,srcc,srcr,
     %        min1,max1,min2,max2, n1,n2,n3,dest,size)
*
	nwords=6*(2*((n1*n3)/2)+1)*size
	mode=2
	direction=pe_mycol
	goto 1
*
	entry RPN_COMM_gather_e2x3(srca,srcc,srcr,
     %        min1,max1,min2,max2, n1,n2,n3,dest,size)
*
	nwords=6*(2*((n1*n3)/2)+1)*size
	mode=2
	direction=pe_myrow
	goto 1
*
	end
*
	subroutine RPN_COMM_compress(array,minx,maxx,miny,maxy,
     %                           nil,njl,nk)
	implicit none
	integer minx,maxx,miny,maxy,nil,njl,nk
	integer array(*)
*
	integer expanded, compressed
	real *8 expanded8, compressed8
	pointer (expanded_,expanded(minx:maxx,miny:maxy,nk))
	pointer (expanded8_,expanded8(minx:maxx,miny:maxy,nk))
	pointer (compressed_,compressed(nil,njl,nk))
	pointer (compressed8_,compressed8(nil,njl,nk))
*
	integer i,j,k
*
	compressed_ = loc(array)
	expanded_ = loc(array)
*
	do k=1,nk
	do j=1,njl
	do i=1,nil
	  compressed(i,j,k)=expanded(i,j,k)
	enddo
	enddo
	enddo
*
	entry RPN_COMM_compress8(array,minx,maxx,miny,maxy,
     %                           nil,njl,nk)
*
	compressed8_ = loc(array)
	expanded8_ = loc(array)
*
	do k=1,nk
	do j=1,njl
	do i=1,nil
	  compressed8(i,j,k)=expanded8(i,j,k)
	enddo
	enddo
	enddo
*
	return
*
*
	entry RPN_COMM_expand(array,minx,maxx,miny,maxy,
     %                           nil,njl,nk)
*
	compressed_ = loc(array)
	expanded_ = loc(array)
*
	do k=nk,1,-1
	do j=njl,1,-1
	do i=nil,1,-1
	  expanded(i,j,k)=compressed(i,j,k)
	enddo
	enddo
	enddo
*
*
	entry RPN_COMM_expand8(array,minx,maxx,miny,maxy,
     %                           nil,njl,nk)
*
	compressed8_ = loc(array)
	expanded8_ = loc(array)
*
	do k=nk,1,-1
	do j=njl,1,-1
	do i=nil,1,-1
	  expanded8(i,j,k)=compressed8(i,j,k)
	enddo
	enddo
	enddo
*
	return
	end
*
	subroutine RPN_COMM_qadl(ipe,ni,nj,i0,in,j0,jn)
	include 'rpn_comm.h'
	include 'mpif.h'
	ilim = (ni + pe_nx -1) / pe_nx
	jlim = (nj + pe_ny -1) / pe_ny
	ifact = ipe/pe_nx
	j0 = jlim*(ipe/pe_nx) + 1
	jn = j0 + jlim -1
	i0 = ilim*mod(ipe,pe_nx) + 1
	in = i0 + ilim -1
	in=min(in,ni)
	jn=min(jn,nj)
	return
	end
	subroutine RPN_COMM_diag(Sub,Array,Minx,Maxx,Miny,Maxy,Ni,Nj,Nk,
     %             R_8,Nr,Tmp_8,Fast)
	implicit none
	external sub
	integer Minx,Maxx,Miny,Maxy,Ni,Nj,Nk,Nr
	logical Fast
	real array(Minx:Maxx,Miny:Maxy,Nk)
	real *8 R_8(Nk,Nr), Tmp_8(Miny:Maxy,Nk,Nr)
*
	include 'rpn_comm.h'
	include 'mpif.h'
*
	integer nelem,status,ierr
*
*	pass 1 WEST to EAST
*
	nelem = (Maxy-Miny+1)*Nk*Nr
*
	if(bnd_west) then  ! initialize WEST to EAST collect
	   call Sub(Array,Minx,Maxx,Miny,Maxy,Ni,Nj,Nk,R_8,Nr,Tmp_8,
     %              1,.true.)
	else  ! get result from WEST neighbor continue collection
	   call MPI_RECV(Tmp_8,nelem,MPI_DOUBLE_PRECISION,
     %                   pe_id(pe_mex-1,pe_mey),pe_id(pe_mex-1,pe_mey),
     %                   MPI_COMM_WORLD,status,ierr)
	   call Sub(Array,Minx,Maxx,Miny,Maxy,Ni,Nj,Nk,R_8,Nr,Tmp_8,
     %              1,.false.)
	endif
	if(.not. bnd_east) then  ! send result to EAST neighbor
	   call MPI_SSEND(Tmp_8,nelem,MPI_DOUBLE_PRECISION,
     %                    pe_id(pe_mex+1,pe_mey),pe_me,
     %                    MPI_COMM_WORLD,status,ierr)
	endif
*
*	broadcast partial result to row
*
	call MPI_BCAST(Tmp_8,nelem,MPI_DOUBLE_PRECISION,
     %                 pe_id(pe_nx-1,pe_mey),pe_myrow,ierr)
*
*	pass 2 NORTH to SOUTH  (EAST column only)
*
	if(bnd_north) then  ! initialize NORTH to SOUTH collect
	  call Sub(Array,Minx,Maxx,Miny,Maxy,Ni,Nj,Nk,R_8,Nr,Tmp_8,
     %              2,.true.)
	else  ! get result from NORTH neighbor continue collection
	  call MPI_RECV(R_8,Nr*Nk,MPI_DOUBLE_PRECISION,
     %                   pe_id(pe_mex,pe_mey+1),pe_id(pe_mex,pe_mey+1),
     %                   MPI_COMM_WORLD,status,ierr)
	  call Sub(Array,Minx,Maxx,Miny,Maxy,Ni,Nj,Nk,R_8,Nr,Tmp_8,
     %              2,.false.)
	endif
	if(.not. bnd_south) then  ! send result to SOUTH neighbor
	  call MPI_SSEND(R_8,Nr*Nk,MPI_DOUBLE_PRECISION,
     %                    pe_id(pe_mex,pe_mey-1),pe_me,
     %                    MPI_COMM_WORLD,status,ierr)
	endif
*
*	broadcast final result to column
*
	call MPI_BCAST(R_8,Nr*Nk,MPI_DOUBLE_PRECISION,
     %                 pe_id(pe_mex,0),pe_mycol,ierr)
	return
	end
	integer function RPN_COMM_version()
	RPN_COMM_version=10200
	return
	end
