#if !defined(_RPN_MODEL_MACROS_)
#include <rpnmacros_f.h>
#define _RPN_MODEL_MACROS_ 20000501

#define _cat_(name1,name2) name1##name2
#define _cat3_(name1,name2,name3) name1##name2##name3

#define VMM_KEY(name) vmmk_##name
#define VMM_NAM(name) vmmk_##name##_s
#define VAR_PTR(name) name##_

#define VMM_GET_VAR(name) vmmget(VMM_KEY(name),VAR_PTR(name),name)
#define VMM_CREATE(_name_,_size_,_class_,_attr_) VMM_KEY(_name_)=vmmcre(VMM_NAM(_name_),_size_,_class_,_attr_)

#define DCL_DYNVAR(_COM_,__TOKEN__,TYPE,DIMS)~~\
TYPE _COM_##_##__TOKEN__##DIMS~~\
pointer(VAR_PTR(_COM_##_##__TOKEN__),_COM_##_##__TOKEN__)~~\
common/_COM_/VAR_PTR(_COM_##_##__TOKEN__)

#define DCL_VMMVAR(_COM_,__TOKEN__,TYPE,DIMS)~~\
integer VMM_KEY(__TOKEN__)~~\
character*8 _cat3_(vmmk_,__TOKEN__,_s)~~\
TYPE __TOKEN__##DIMS~~\
pointer(VAR_PTR(__TOKEN__),__TOKEN__)~~\
common/_COM_/VMM_KEY(__TOKEN__)~~\
common/_cat_(_COM_,_n)/_cat3_(vmmk_,__TOKEN__,_s)

#define AUTOMATIC(name,type,dims) ~~\
type _cat_(name,dims)~~\
pointer(_cat_(name,_),name)

#define DYNAMIC(name,type,dims) ~~\
type _cat_(name,dims)~~\
pointer(name##_,name)

#define AUTOMATIC_DEALLOC(name) ~~\
call unstakw(_cat_(name,_))

#define AUTOMATIC_ALLOC_8(name,nwords) ~~\
call stkmemw(nwords*2,_cat_(name,_))

#define AUTOMATIC_ALLOC(name,nwords) ~~\
call stkmemw(nwords,_cat_(name,_))

#define SMALL_ALLOC_8(name,nwords) ~~\
call small_alloc(_cat_(name,_),nwords,dyn_alloc_error,8)

#define SMALL_ALLOC(name,nwords) ~~\
call small_alloc(_cat_(name,_),nwords,dyn_alloc_error,1)

#define DYNAMIC_ALLOC_8(name,nwords) ~~\
call hpalloc(_cat_(name,_),nwords,dyn_alloc_error,8)

#define DYNAMIC_ALLOC(name,nwords) ~~\
call hpalloc(_cat_(name,_),nwords,dyn_alloc_error,1)

#define MARK_COMMON_BEG(_COM_) ~~\
integer _cat_(_COM_,_first(-1:1))~~\
common /_COM_/_cat_(_COM_,_first)

#define MARKED_COMMON_BEG(_COM_) _cat_(_COM_,_first(1))

#define MARK_COMMON_END(_COM_) ~~\
integer _cat_(_COM_,_last)~~\
common /_COM_/_cat_(_COM_,_last)

#define COMMON_SIZE(_COM_) (loc(_cat_(_COM_,_last))-loc(_cat_(_COM_,_first(1))))/\
(loc(_cat_(_COM_,_first(0)))-loc(_cat_(_COM_,_first(-1))))

#define COMMON_INIT(_COM_,_value_) ~~\
do i=1,COMMON_SIZE(_COM_) ~~\
_cat_(_COM_,_first)(i)=_value_ ~~\
enddo

#define COMMON_BROADCAST(_COM_) ~~\
call RPN_COMM_bcst_world(_cat_(_COM_,_first),_cat_(_COM_,_last),0)

#define XDIST_DIM   l_minx,l_maxx
#define LXDIST_DIM   l_minx,l_maxx
#define XDIST_SIZ   (l_maxx-l_minx+1)
#define LXDIST_SIZ   (l_maxx-l_minx+1)
#define XDIST_SHAPE l_minx:l_maxx
#define LXDIST_SHAPE l_minx:l_maxx
#define YDIST_DIM   l_miny,l_maxy
#define LYDIST_DIM   l_miny,l_maxy
#define YDIST_SIZ   (l_maxy-l_miny+1)
#define LYDIST_SIZ   (l_maxy-l_miny+1)
#define YDIST_SHAPE l_miny:l_maxy
#define LYDIST_SHAPE l_miny:l_maxy
#define LDIST_DIM   l_minx,l_maxx,l_miny,l_maxy
#define LDIST_SHAPE l_minx:l_maxx,l_miny:l_maxy
#define LDIST_SIZ   ((l_maxx-l_minx+1)*(l_maxy-l_miny+1))

#define DIST_DIM   Minx,Maxx,Miny,Maxy
#define PDIST_DIM   Minx,Maxx,Miny,Maxy
#define PXDIST_DIM   Minx,Maxx
#define PYDIST_DIM   Miny,Maxy
#define DIST_SHAPE Minx:Maxx,Miny:Maxy
#define PDIST_SHAPE Minx:Maxx,Miny:Maxy
#define PXDIST_SHAPE Minx:Maxx
#define PYDIST_SHAPE Miny:Maxy

#define DEF1D(arg1) DEF1D_(arg1)
#define DEF2D(arg1) DEF2D_(arg1)
#define DEF3D(arg1,arg2) DEF3D_(arg1,arg2)
#define DEF1D_(minz,maxz) (maxz-minz+1)
#define DEF2D_(minx,maxx,miny,maxy) ((maxx-minx+1)*(maxy-miny+1))
#define DEF3D_(minx,maxx,miny,maxy,nk) ((maxx-minx+1)*(maxy-miny+1)*nk)

#define ARRAY3D    ((maxx-minx+1)*(maxy-miny+1)*nk)
#define ARRAY2D    ((maxx-minx+1)*(maxy-miny+1))
#define ARRAY1DX   (maxx-minx+1)
#define ARRAY1DY   (maxy-miny+1)
#define LARRAY3D  ((l_maxx-l_minx+1)*(l_maxy-l_miny+1)*l_nk)
#define LARRAY2D  ((l_maxx-l_minx+1)*(l_maxy-l_miny+1))
#define LARRAY1DX (l_maxx-l_minx+1)
#define LARRAY1DY (l_maxy-l_miny+1)

#define VMM_LIST_ADD(array,name) \
array(1)=array(1)+1~~\
array(array(1))=VMM_KEY(name)

#define VMM_LIST_LOAD(array) vmmlod(array(2),array(1))

#define VMM_LIST_INIT(array) array(1)=0

#define VMM_LIST_DCL(array) integer array(2048)

#define NONSENSE -1.0e+30
#define MISSING 1.0e+12

#define VALID(a) (a.NE.MISSING)

#define MARK_DST  ~~\
do i=minx,maxx ~~ DST(i,1,k)= MISSING~~enddo~~\
do j=miny,maxy ~~ DST(1,j,k)= MISSING~~enddo

#define RANGE_X(beg,end)~~beg=minx~~end=maxx~~\
do while (.NOT.VALID(SRC(beg,1,k)))~~beg=beg+1~~enddo~~\
do while (.NOT.VALID(SRC(end,1,k)))~~end=end-1~~enddo~~

#define RANGE_Y(beg,end)~~beg=miny~~end=maxy~~\
do while (.NOT.VALID(SRC(1,beg,k)))~~beg=beg+1~~enddo~~\
do while (.NOT.VALID(SRC(1,end,k)))~~end=end-1~~enddo~~

#define MARK_DST2(minx,maxx,miny,maxy)~~\
do i=minx,maxx ~~ DST(i,1,k)= MISSING~~enddo~~\
do j=miny,maxy ~~ DST(1,j,k)= MISSING~~enddo

#define RANGE_X2(beg,end,minx,maxx)~~beg=minx~~end=maxx~~\
do while (.NOT.VALID(SRC(beg,1,k)))~~beg=beg+1~~enddo~~\
do while (.NOT.VALID(SRC(end,1,k)))~~end=end-1~~enddo~~

#define RANGE_Y2(beg,end,miny,maxy)~~beg=miny~~end=maxy~~\
do while (.NOT.VALID(SRC(1,beg,k)))~~beg=beg+1~~enddo~~\
do while (.NOT.VALID(SRC(1,end,k)))~~end=end-1~~enddo~~

#define MUST_BE_VALID(a)~~if(.not.VALID(a)) call outch()

#endif
